## START: Set by rpmautospec
## (rpmautospec version 0.2.6)
%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
## END: Set by rpmautospec

%global pecl_name   gnupg
%global ini_name    40-%{pecl_name}.ini
%global min_php     5.3.2
%global min_gpgme   1.3.0

# disable ZTS builds for now.
%bcond_with zts
%bcond_without tests

Name:           php-pecl-%{pecl_name}
Version:        1.5.1
Release:        %{autorelease}
Summary:        Wrapper around the gpgme library

License:        BSD
URL:            https://pecl.php.net/package/%{pecl_name}
Source0:        https://pecl.php.net/get/%{pecl_name}-%{version}.tgz
Source1:        Makefile

BuildRequires:  gcc
BuildRequires:  gcc-g++
BuildRequires:  gpgme-devel >= %{min_gpgme}
BuildRequires:  make
BuildRequires:  php-devel
BuildRequires:  php-pear
BuildRequires:  pkgconfig(rpm)

Requires:       php(zend-abi) = %{php_zend_api}
Requires:       php(api) = %{php_core_api}
Requires:       php(language) >= %{min_php}
Requires:       gpgme >= %{min_gpgme}

Provides:       php-%{pecl_name} = %{version}
Provides:       php-%{pecl_name}%{?_isa} = %{version}
Provides:       php-pecl(%{pecl_name}) = %{version}
Provides:       php-pecl(%{pecl_name})%{?_isa} = %{version}

%description
This extension provides methods to interact with gnupg.


%prep
%setup -q -c

# Don't install/register tests
%{__sed} -e 's/role="test"/role="src"/' \
    -e '/name="LICENSE"/{s/role="doc"/role="src"/}' \
    -e '/name="EXPERIMENTAL"/{s/role="doc"/role="src"/}' \
    -i package.xml

%{__mv} %{pecl_name}-%{version} NTS

cd NTS
# Sanity check
extver=$(%{__sed} -n -E -e '/#define PHP_GNUPG_VERSION/{s/.*"([^"]+)".*$/\1/p}' php_%{pecl_name}.h)
if test "x${extver}" != "x%{version}"; then
    : Error: Upstream extension version is ${extver}, expecting %{version}.
    exit 1
fi
cd ..

%if %{with zts}
# Duplicate source tree for NTS / ZTS build
%{__cp} -pr NTS ZTS
%endif

# Create configuration file
%{__cat} <<EOF | tee %{ini_name}
; Enable '%{summary}' extension module
extension=%{pecl_name}.so

EOF

%build
cd NTS
%{_bindir}/phpize
# unwrap lines in configure
%{__sed} -i -z -e 's/\\\n//g' configure
%{configure} --with-php-config=%{_bindir}/php-config
%{make_build}
cd ..

%if %{with zts}
cd ZTS
%{_bindir}/zts-phpize
%{__sed} -i -z -e 's/\\\n//g' configure
%{configure} --with-php-config=%{_bindir}/zts-php-config
%{make_build}
cd ..
%endif


%install
cd NTS
%{make_install} INSTALL_ROOT=%{buildroot}
cd ..
# install config file
%{__install} -D -m 644 %{ini_name} %{buildroot}%{php_inidir}/%{ini_name}

%if %{with zts}
cd ZTS
%{make_install} INSTALL_ROOT=%{buildroot}
cd ..
# install config file
%{__install} -D -m 644 %{ini_name} %{buildroot}%{php_ztsinidir}/%{ini_name}
%endif

# Install XML package description
%{__install} -D -m 644 package.xml %{buildroot}%{pecl_xmldir}/%{name}.xml

# Documentation
for i in $(%{__sed} -n -E -e '/role="doc"/{s/^.*name="([^"]+)".*$/\1/p}' package.xml)
do %{__install} -Dpm 644 NTS/$i %{buildroot}%{pecl_docdir}/%{pecl_name}/$i
done


%check
cd NTS
# Minimal load test for NTS extension
%{__php} --no-php-ini \
    --define extension=%{buildroot}/%{php_extdir}/%{pecl_name}.so \
    --modules | grep -q %{pecl_name}

%if %{with tests}
# Upstream test suite for NTS extension
TEST_PHP_EXECUTABLE=%{__php} \
TEST_PHP_ARGS="-n -d extension=%{buildroot}/%{php_extdir}/%{pecl_name}.so" \
NO_INTERACTION=1 \
REPORT_EXIT_STATUS=1 \
%{__php} -n run-tests.php --show-diff
%endif

cd ..

%if %{with zts}
cd ZTS
# Minimal load test for ZTS extension
%{__ztsphp} --no-php-ini \
    --define extension=%{buildroot}/%{php_ztsextdir}/%{pecl_name}.so \
    --modules | grep -q %{pecl_name}

%if %{with tests}
# Upstream test suite for ZTS extension
TEST_PHP_EXECUTABLE=%{__ztsphp} \
TEST_PHP_ARGS="-n -d extension=%{buildroot}/%{php_ztsextdir}/%{pecl_name}.so" \
NO_INTERACTION=1 \
REPORT_EXIT_STATUS=1 \
%{__ztsphp} -n run-tests.php --show-diff
%endif

cd ..
%endif


%files
%license NTS/LICENSE
%doc %{pecl_docdir}/%{pecl_name}
%{pecl_xmldir}/%{name}.xml
%config(noreplace) %{php_inidir}/%{ini_name}
%{php_extdir}/%{pecl_name}.so

%if %{with zts}
%config(noreplace) %{php_ztsinidir}/%{ini_name}
%{php_ztsextdir}/%{pecl_name}.so
%endif


%changelog
* Sat Aug 13 2022 Jarryd Lisher <jarryd@jlisher.com> 1.5.1-1
- Initial Release
